package robo;

import java.io.BufferedOutputStream;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Set;

public class MakeBuildingBin {
	Building building = null;
	ArrayList<Building> buildingList = null;
	
	public MakeBuildingBin(){
		
	}
	public MakeBuildingBin(ArrayList<Building> buildingl){
		if (buildingList != null) buildingList.clear();
		buildingList = buildingl;
	}
	public void makeEmptyBuildingBin(String path){
		try {
			//DataOutputStream buildbin = new DataOutputStream(new FileOutputStream("bin/building.bin"));
			//DataOutputStream buildbin = new DataOutputStream(new FileOutputStream(path));
			DataOutputStream buildbin = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path)));
			tools.General.writeInt(buildbin, 0);//offset data
			tools.General.writeInt(buildbin, 0);//offset data
			tools.General.writeInt(buildbin, 0);//offset data
			tools.General.writeInt(buildbin, 0);//offset data
			buildbin.flush();
			buildbin.close();
		} catch (FileNotFoundException e) {
			System.out.println("FileNotFoundException: " + e);
		} catch (IOException e) {
			System.out.println("IOException: " + e);
		}
	}
	public void writeASetBuildingBin(String path){
		try{
			//BinWriter f = new BinWriter(path);
			DataOutputStream buildbin = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path)));
		
			//
			tools.General.writeInt(buildbin, 0);
			tools.General.writeInt(buildbin, 0);
			tools.General.writeInt(buildbin, 0);
			tools.General.writeInt(buildbin, buildingList.size());
			System.out.println("Total building: " + buildingList.size());
			// 
		
			int i = 0;
			int Bnumber = buildingList.size();
			for (i = 0; i < Bnumber; i++) {
				building = (Building) buildingList.get(i);
				int area_1_floor = (int)building.buildingArea;	//
				tools.General.writeInt(buildbin, 16+(building.outlineX.length)*2);		// m_size
				tools.General.writeInt(buildbin, i+1);								// m_id
				tools.General.writeInt(buildbin, (int)building.cx);		// m_center
				tools.General.writeInt(buildbin, (int)building.cy);		// m_center
				tools.General.writeInt(buildbin, building.floorNum);						// NumFloor
				tools.General.writeInt(buildbin, 0);									// Attribute
				tools.General.writeInt(buildbin, 0);									// IsBurning
				tools.General.writeInt(buildbin, 0);									// PercentageOfBurned
				tools.General.writeInt(buildbin, 0);									// PercentageOfBroken
				tools.General.writeInt(buildbin, 1);									// m_nConnectNode
				tools.General.writeInt(buildbin, (int)building.nodeId);						// m_connectNode
				//f.write(bid);								// m_buildingId
				tools.General.writeInt(buildbin, 0); //shape
				tools.General.writeInt(buildbin, area_1_floor);						// Area_1_floor
				tools.General.writeInt(buildbin, area_1_floor*building.floorNum);			// Area_all_floors
				tools.General.writeInt(buildbin, 0);									// Type
				tools.General.writeInt(buildbin, building.outlineX.length);				// m_nNode
				for(int j=0; j<building.outlineX.length; j++){
					tools.General.writeInt(buildbin, (int)building.outlineX[j]);	// m_apexes
					tools.General.writeInt(buildbin, (int)building.outlineY[j]);	// m_apexes
				}
				building.id = i+1;
			}
			/*int bid = 1;
			Iterator it = buildingSet.iterator();
			while(it.hasNext()){
				Building b = (Building)it.next();
				int area_1_floor = (int)Math.round(b.buildingArea*100.0);	//
				tools.General.writeInt(buildbin, 16+(b.outlineX.length)*2);		// m_size
				tools.General.writeInt(buildbin, bid);								// m_id
				tools.General.writeInt(buildbin, (int)b.cx);		// m_center
				tools.General.writeInt(buildbin, (int)b.cy);		// m_center
				tools.General.writeInt(buildbin, b.floorNum);						// NumFloor
				tools.General.writeInt(buildbin, 0);									// Attribute
				tools.General.writeInt(buildbin, 0);									// IsBurning
				tools.General.writeInt(buildbin, 0);									// PercentageOfBurned
				tools.General.writeInt(buildbin, 0);									// PercentageOfBroken
				tools.General.writeInt(buildbin, 1);									// m_nConnectNode
				tools.General.writeInt(buildbin, (int)b.nodeId);						// m_connectNode
				//f.write(bid);								// m_buildingId
				tools.General.writeInt(buildbin, 0); //shape
				tools.General.writeInt(buildbin, area_1_floor);						// Area_1_floor
				tools.General.writeInt(buildbin, area_1_floor*b.floorNum);			// Area_all_floors
				tools.General.writeInt(buildbin, 0);									// Type
				tools.General.writeInt(buildbin, b.outlineX.length);				// m_nNode
				for(int i=0;i<b.outlineX.length;i++){
					tools.General.writeInt(buildbin, (int)b.outlineX[i]);	// m_apexes
					tools.General.writeInt(buildbin, (int)b.outlineY[i]);	// m_apexes
				}
				b.id = bid;
				bid++;
				//
			}*/
			buildbin.flush();
			buildbin.close();
		} catch (FileNotFoundException e) {
			System.out.println("FileNotFoundException: " + e);
		} catch (IOException e) {
			System.out.println("IOException: " + e);
		}
	}
	public ArrayList<Building> getBuildingList(){
		return buildingList;
	}
	
	public void setBuildingList(ArrayList<Building> buildingl){
		buildingList = buildingl;
	}
}
